Bug 8913 - Improve acquisitions navigation
Summary: Improve acquisitions navigation
Status: CLOSED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Acquisitions (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Bugs List
QA Contact: Katrin Fischer
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-10-12 20:02 UTC by Owen Leonard
Modified: 2014-05-26 21:04 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Bot Control: ---
When did the bot last check this:
Who signed the patch off:
Text to go in the release notes:


Attachments
Bug 8913 - Improve acquisitions navigation (22.80 KB, patch)
2012-10-17 18:40 UTC, Owen Leonard
Details | Diff | Splinter Review
vendor buttons on contract confusing (40.60 KB, image/png)
2012-10-17 19:07 UTC, Nicole C. Engard
Details
Bug 8913 [Revised] Improve acquisitions navigation (22.80 KB, patch)
2012-10-18 14:40 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 8913 [Follow-up] Improve acquisitions navigation (2.03 KB, patch)
2012-10-18 19:40 UTC, Owen Leonard
Details | Diff | Splinter Review
[SIGNED-OFF] Bug 8913 [Revised] Improve acquisitions navigation (22.86 KB, patch)
2012-10-19 11:45 UTC, Kyle M Hall
Details | Diff | Splinter Review
[SIGNED-OFF] Bug 8913 [Follow-up] Improve acquisitions navigation (2.09 KB, patch)
2012-10-19 11:46 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 8913 [Revised] Improve acquisitions navigation (29.56 KB, patch)
2013-02-04 15:35 UTC, Owen Leonard
Details | Diff | Splinter Review
[SIGNED-OFF] Bug 8913 [Revised] Improve acquisitions navigation (29.63 KB, patch)
2013-02-05 14:06 UTC, Nicole C. Engard
Details | Diff | Splinter Review
Bug 8913 [Revised] Improve acquisitions navigation (31.13 KB, patch)
2013-02-11 14:55 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 8913 [Revised] Improve acquisitions navigation (31.81 KB, patch)
2013-02-12 20:44 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Owen Leonard 2012-10-12 20:02:11 UTC
Many acquisitions pages do not follow the convention which Koha uses elsewhere distinguishing between actions and views when creating navigation via buttons and menus. The general rule: toolbar buttons are for actions, sidebar menus are for views. Vendor-related pages in particular can be improved by adding a menu for:

- Baskets
- Basket groups
- Contracts
- Invoices
- Uncertain prices

The toolbar can be refined to include:

- New
  -- Basket
  -- Contract
  -- Vendor
- Edit vendor
- Delete vendor
- Receive shipments
Comment 1 Owen Leonard 2012-10-17 18:40:30 UTC Comment hidden (obsolete)
Comment 2 Nicole C. Engard 2012-10-17 19:05:26 UTC
Owen,

The Uncertain Prices tab links to: http://localhost:8888/cgi-bin/koha/acqui/uncertainprice.pl?booksellerid=1&owner=1

Also, it's kind of annoying that clicking basket and basket groups makes the menu on the left go away.  Still poking around to see what else I can find.
Comment 3 Nicole C. Engard 2012-10-17 19:07:14 UTC
Created attachment 12892 [details]
vendor buttons on contract confusing

At the top of the contract page there are buttons to edit and delete the vendor - they kind of seem out of place there.

Nicole
Comment 4 Nicole C. Engard 2012-10-17 19:07:42 UTC
Marking failed qa because of the broken link. Other comments are just suggestions, not bugs.

Nicole
Comment 5 Owen Leonard 2012-10-18 14:40:40 UTC Comment hidden (obsolete)
Comment 6 Owen Leonard 2012-10-18 14:46:58 UTC
(In reply to comment #2)

> The Uncertain Prices tab links to: http://localhost:8888/...

Whoops. Funny, it worked fine on my system ;)

> Also, it's kind of annoying that clicking basket and basket groups makes the
> menu on the left go away.

The baskets link points to booksellers.pl which is both the baskets page for an individual vendor and the search results page for a vendor search. I was looking at it more as the latter, but I see now that it would make sense for a follow-up to add the sidebar menu if booksellerid is defined.

(In reply to comment #3)
> At the top of the contract page there are buttons to edit and delete the
> vendor - they kind of seem out of place there.

My reorganization of acquisitions-related navigation tries to organize things in sensible groups, so in this case my goal is to group all vendor-specific pages together and offer vendor-related views and actions on each of those pages. Since contracts are specifically associated with vendors I thought this grouping made sense. However, I'm not an acquisitions user so I hope others can give their opinions too.
Comment 7 Owen Leonard 2012-10-18 14:50:18 UTC
Oh, and the fact that basket groups doesn't have the menu is because I haven't worked on every acquisitions page yet. If folks think I'm on the right track here I will keep going.
Comment 8 Nicole C. Engard 2012-10-18 18:34:46 UTC
I like it and think you're on the right track :) Will test the newest patch.

Nicole
Comment 9 Nicole C. Engard 2012-10-18 18:42:42 UTC
All looks good in the revised patch... do I sign off or wait for more feedback and additions to menu pages?

Nicole
Comment 10 Owen Leonard 2012-10-18 19:40:49 UTC Comment hidden (obsolete)
Comment 11 Kyle M Hall 2012-10-19 11:45:39 UTC Comment hidden (obsolete)
Comment 12 Kyle M Hall 2012-10-19 11:46:16 UTC Comment hidden (obsolete)
Comment 13 Kyle M Hall 2012-10-19 11:48:18 UTC
Those two patches look good, but shouldn't basket groups have the side tabs as well? I suppose invoices should as well, technically, but that space is already taken by the invoice search.
Comment 14 Nicole C. Engard 2012-10-19 12:09:45 UTC
Also while working on help files I found an acq page that needs these new menus:

/cgi-bin/koha/acqui/uncertainprice.pl

I was going to fix the breadcrumbs on this, but if you're changing all acq pages navigation I figured you can just wrap that fix up in your patches.
Comment 15 Owen Leonard 2012-10-19 13:00:01 UTC
(In reply to comment #14)
> I was going to fix the breadcrumbs on this, but if you're changing all acq
> pages navigation I figured you can just wrap that fix up in your patches.

Yes, both those fixes are in the first patch.
Comment 16 Jonathan Druart 2012-11-13 14:51:29 UTC
QA Comments:

Hi Owen,
On the acqui/booksellers.pl?booksellerid=XX view I see the vendor menu and the acquisition menu, is it normal ? I suppose yes.
So maybe we want to have the acq menu for the uncertainprice page too ?

Otherwise nothing to say, it is a great patch for the acq module ergonomy :)
Comment 17 Owen Leonard 2012-11-14 16:40:22 UTC
(In reply to comment #16)
> On the acqui/booksellers.pl?booksellerid=XX view I see the vendor menu and
> the acquisition menu, is it normal ? I suppose yes.

When you say "acquisition menu" you mean the menu in the left-hand sidebar with Late orders, Suggestions, Invoices etc.?

> So maybe we want to have the acq menu for the uncertainprice page too ?

Perhaps the acq menu belongs on every acquisitions page which shows the left-hand sidebar, under the view menu if it is present?
Comment 18 Jonathan Druart 2012-11-19 09:11:56 UTC
(In reply to comment #17)
> (In reply to comment #16)
> > On the acqui/booksellers.pl?booksellerid=XX view I see the vendor menu and
> > the acquisition menu, is it normal ? I suppose yes.
> 
> When you say "acquisition menu" you mean the menu in the left-hand sidebar
> with Late orders, Suggestions, Invoices etc.?

Yes that's it

> > So maybe we want to have the acq menu for the uncertainprice page too ?
> 
> Perhaps the acq menu belongs on every acquisitions page which shows the
> left-hand sidebar, under the view menu if it is present?

Yes but it seems to be displayed for all acquisition pages except the uncertainprice page.
Comment 19 Katrin Fischer 2012-12-02 21:08:31 UTC
Hi Owen,

I found some problems:

invoices.pl
- the vendor in the table is now a link, but the booksellerid is 
  missing from the URL.

basketgroup.pl?booksellerid=2
- doesn't show the new navigation, but uncertain prices does? 

aqcontract.pl?booksellerid=2 and others
- invoices link doesn't does go to the correct page, but doesn't show invoices   
  for the vendor (empty list)

Could you take a look?
Comment 20 Owen Leonard 2013-02-04 15:35:56 UTC Comment hidden (obsolete)
Comment 21 Nicole C. Engard 2013-02-05 14:06:52 UTC Comment hidden (obsolete)
Comment 22 Katrin Fischer 2013-02-10 22:10:37 UTC
Testing this now.
Comment 23 Katrin Fischer 2013-02-10 22:42:52 UTC
Hi Owen,

I found a problem:
1) "Delete vendor" button shows up on some pages. The button should only show up when no baskets have been created for vendor yet.

Pages I found the problem are:
/cgi-bin/koha/acqui/uncertainprice.pl?booksellerid=2&owner=1
/cgi-bin/koha/admin/aqcontract.pl?booksellerid=2

2) The new invoices page is missing the toolbar. If you want to add it there too, this could be a separate bug.

Failing QA, because 1) could cause trouble. Can you please fix in a follow-up? Thanks!
Comment 24 Owen Leonard 2013-02-11 14:55:14 UTC Comment hidden (obsolete)
Comment 25 Katrin Fischer 2013-02-12 20:44:21 UTC
Created attachment 15281 [details] [review]
Bug 8913 [Revised] Improve acquisitions navigation

This patch adds a new menu for vendor-related pages in which
vendor related "views" can be linked to: baskets, basket groups,
contracts, invoices, uncertain prices.

The acquisitions toolbar is pared down to vendor-related actions:
New basket, contract, or vendor; edit vendor, delete vendor,
receive shipment.

Other small improvements have been made to other pages: corrections
to breadcrumbs and title tags, adding useful links betweeen pages.

Vendor menu and toolbar are added to booksellers.pl
when there is only one "search result" (i.e. a vendor id is passed).

- Menu appears when booksellerid variable is present
- Redundant heading removed
- Additional variables added to enable proper display of the toolbar

- Revision corrects broken links pointed out by QA.
- Revision adds check of existing baskets and subscriptions as a
  condition on display of the vendor delete button.

TODO: Add coverage of Basket groups page.

To test, navigate Acquisitions pages and test as many links and buttons
as you can, confirming that nothing is broken on vendor pages, invoice
pages, contract pages, uncertain price pages, etc.

Signed-off-by: Katrin Fischer <Katrin.Fischer.83@web.de>
All tests and QA script pass.

Tests done:
1) New toolbar - vendor search
  - no results = button to create new vendor shows
  - 1 result = additional new options show
  - more than one result = button to create new vendor shows

2) Vendor views
  - acq toolbar consistent with 1 result in vendor search
  - new tabs on the left
  - checked all links have the needed parameters and work correctly

3) New toolbar - different pages
  - Toolbar is formatted consistently
  - Delete vendor shows only up when it should - no baskets or
    subscriptions
  - Links work correctly

Works nicely, great groundwork for further improvements.

TODO Add new toolbar to (new) invoices page.
Comment 26 Jared Camins-Esakov 2013-02-15 23:47:19 UTC
I intend to push this patch, since I think it's an improvement as it is, but I spotted a few issues that I'd like to point out and get commentary on before I do so (in particular, I'd like to know if I've missed the point of the new navigation anywhere, so I can retest if I was doing things wrong):
1) When viewing a vendor, the tabs on the left are too high, and wasn't sure whether they were specific to the vendor I was viewing (they were).
2) The tabs on the left do not highlight when you're viewing a specific page.
3) The bullet list with "Late orders," etc., shows up floating underneath the tabs on the Baskets page.
4) (you mentioned this) The basket groups page doesn't use the new navigation.
5) (Katrin mentioned this) The invoices page doesn't use the new navigation.
6) If I create a new contract, the buttons for editing and deleting the vendor appear right above the form for entering information about the new contract.
7) The late orders page doesn't use the new navigation.

Also, a question that may or may not be another issue to address in follow-ups: in what way are suggestions related to the rest of the Acquisitions module?

Finally, I hope once this is pushed you'll update the YUI toolbars to use Bootstrap. :)
Comment 27 Owen Leonard 2013-02-16 22:42:28 UTC
(In reply to comment #26)
> 1) When viewing a vendor, the tabs on the left are too high, and wasn't sure
> whether they were specific to the vendor I was viewing (they were).

Can you explain what you mean by too high?

> 2) The tabs on the left do not highlight when you're viewing a specific page.

Good point!

> 3) The bullet list with "Late orders," etc., shows up floating underneath
> the tabs on the Baskets page.

Yes, I'm uncertain about how to handle some of those links. This issue is connected to 7):

> 7) The late orders page doesn't use the new navigation.

Late orders could be linked to a particular vendor (so that the path must be vendor-> late orders for that vendor) or it could be a place to start from scratch (late orders -> choose a vendor). Or both. How to handle links like that which are more general? That bulleted list is what we have.

> Also, a question that may or may not be another issue to address in
> follow-ups: in what way are suggestions related to the rest of the
> Acquisitions module?

If you don't have pending suggestions showing up on the staff home page, the only way to access suggestions in the staff client is through acquisitions. That's the only place where we have a link to it.
Comment 28 Katrin Fischer 2013-02-18 07:47:15 UTC
I have been thinking about the point Jared made about the bullet list navigatoin below the view tabs. It doesn't seem to fit well into our existing naviation structures right now. One idea I had that would make it fit a bit better would be adding it to the top navigation, either as it's own entry with subentries like more or a new submenu under more acquisitions. Not sure what you think about that?
Comment 29 Jared Camins-Esakov 2013-02-20 14:17:48 UTC
This patch has been pushed to master.